<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SymbolLookup/Display.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SymbolLookup/Display.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SymbolLookup/Display.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="comment">// Copyright (C) 2005 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line">#ifndef Synopsis_SymbolLookup_Display_hh_</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line">#define Synopsis_SymbolLookup_Display_hh_</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">#include &lt;Synopsis/SymbolLookup.hh&gt;</span>
<a id="line11"></a><span class="lineno">11</span>
<a id="line12"></a><span class="lineno">12</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line13"></a><span class="lineno">13</span><span class="line">{</span>
<a id="line14"></a><span class="lineno">14</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/SymbolLookup.html" title="namespace Synopsis::SymbolLookup">SymbolLookup</a></span>
<a id="line15"></a><span class="lineno">15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno">16</span>
<a id="line17"></a><span class="lineno">17</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html" title="class Synopsis::SymbolLookup::SymbolDisplay">SymbolDisplay</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolVisitor.html" title="class Synopsis::SymbolLookup::SymbolVisitor">SymbolVisitor</a></span>
<a id="line18"></a><span class="lineno">18</span><span class="line">{</span>
<a id="line19"></a><span class="lineno">19</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line20"></a><span class="lineno">20</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::SymbolDisplay::SymbolDisplay(std::ostream&amp;,size_t)">SymbolDisplay</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;os, <a href="" title="typedef size_t">size_t</a> indent)</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">    : my_os(os), my_indent(indent, ' ') {}</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">  <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::SymbolDisplay::display(const PTree::Encoding&amp;,const Symbol*)">display</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">SymbolLookup::Symbol const</a> *);</span>
<a id="line23"></a><span class="lineno">23</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="" title="member function Synopsis::SymbolLookup::SymbolDisplay::prefix(const std::string&amp;)">prefix</a>(<a href="" title="typedef std::string">std::string const</a> &amp;type)</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">  { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#my_os" title="data member Synopsis::SymbolLookup::SymbolDisplay::my_os">my_os</a> &lt;&lt; <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#my_indent" title="data member Synopsis::SymbolLookup::SymbolDisplay::my_indent">my_indent</a> &lt;&lt; <a href="" title="parameter type">type</a>;}</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.Symbol_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const Symbol*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Symbol.html" title="class Synopsis::SymbolLookup::Symbol">SymbolLookup::Symbol const</a> *);</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.VariableName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const VariableName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/VariableName.html" title="class Synopsis::SymbolLookup::VariableName">SymbolLookup::VariableName const</a> *);</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.ConstName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const ConstName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ConstName.html" title="class Synopsis::SymbolLookup::ConstName">SymbolLookup::ConstName const</a> *);</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.TypeName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const TypeName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/TypeName.html" title="class Synopsis::SymbolLookup::TypeName">SymbolLookup::TypeName const</a> *);</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.TypedefName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const TypedefName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/TypedefName.html" title="class Synopsis::SymbolLookup::TypedefName">SymbolLookup::TypedefName const</a> *);</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.ClassName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const ClassName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ClassName.html" title="class Synopsis::SymbolLookup::ClassName">SymbolLookup::ClassName const</a> *);</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.EnumName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const EnumName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/EnumName.html" title="class Synopsis::SymbolLookup::EnumName">SymbolLookup::EnumName const</a> *);</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.ClassTemplateName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const ClassTemplateName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ClassTemplateName.html" title="class Synopsis::SymbolLookup::ClassTemplateName">SymbolLookup::ClassTemplateName const</a> *);</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.FunctionName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const FunctionName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionName.html" title="class Synopsis::SymbolLookup::FunctionName">SymbolLookup::FunctionName const</a> *);</span>
<a id="line35"></a><span class="lineno">35</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.FunctionTemplateName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const FunctionTemplateName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionTemplateName.html" title="class Synopsis::SymbolLookup::FunctionTemplateName">SymbolLookup::FunctionTemplateName const</a> *);</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#visit_lconst.NamespaceName_S_r" title="member function Synopsis::SymbolLookup::SymbolDisplay::visit(const NamespaceName*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/NamespaceName.html" title="class Synopsis::SymbolLookup::NamespaceName">SymbolLookup::NamespaceName const</a> *);</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#my_os" title="data member Synopsis::SymbolLookup::SymbolDisplay::my_os">my_os</a>;</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">  <a href="" title="typedef std::string">std::string</a>   <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#my_indent" title="data member Synopsis::SymbolLookup::SymbolDisplay::my_indent">my_indent</a>;</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">  <a href="" title="typedef std::string">std::string</a>   <a href="../../../Scopes/Synopsis/SymbolLookup/SymbolDisplay.html#my_name" title="data member Synopsis::SymbolLookup::SymbolDisplay::my_name">my_name</a>;</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">};</span>
<a id="line42"></a><span class="lineno">42</span>
<a id="line43"></a><span class="lineno">43</span><span class="line"><span class="comment">//. The ScopeDisplay class provides an annotated view of the symbol table,</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line"><span class="comment">//. for debugging purposes.</span></span>
<a id="line45"></a><span class="lineno">45</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html" title="class Synopsis::SymbolLookup::ScopeDisplay">ScopeDisplay</a> : <span class="keyword">private</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">SymbolLookup::ScopeVisitor</a></span>
<a id="line46"></a><span class="lineno">46</span><span class="line">{</span>
<a id="line47"></a><span class="lineno">47</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::ScopeDisplay::ScopeDisplay(std::ostream&amp;)">ScopeDisplay</a>(<a href="" title="typedef std::ostream">std::ostream</a> &amp;os) : my_os(os), my_indent(0) {}</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#_tScopeDisplay_l_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::~ScopeDisplay()">~ScopeDisplay</a>() {}</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#display_lconst.Scope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::display(const Scope*)">display</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *s) </span>
<a id="line51"></a><span class="lineno">51</span><span class="line">  { const_cast&lt;SymbolLookup::Scope *&gt;(<a href="" title="parameter s">s</a>)-&gt;accept(<span class="keyword">this</span>);}</span>
<a id="line52"></a><span class="lineno">52</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(TemplateParameterScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">SymbolLookup::TemplateParameterScope</a> *);</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lLocalScope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(LocalScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html" title="class Synopsis::SymbolLookup::LocalScope">SymbolLookup::LocalScope</a> *);</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lPrototypeScope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(PrototypeScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html" title="class Synopsis::SymbolLookup::PrototypeScope">SymbolLookup::PrototypeScope</a> *);</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lFunctionScope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(FunctionScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html" title="class Synopsis::SymbolLookup::FunctionScope">SymbolLookup::FunctionScope</a> *);</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lClass_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(Class*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html" title="class Synopsis::SymbolLookup::Class">SymbolLookup::Class</a> *);</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#visit_lNamespace_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::visit(Namespace*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">SymbolLookup::Namespace</a> *);</span>
<a id="line59"></a><span class="lineno">59</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">  <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#dump_lconst.Scope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::dump(const Scope*)">dump</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *);</span>
<a id="line61"></a><span class="lineno">61</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#indent_l_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::indent()">indent</a>();</span>
<a id="line62"></a><span class="lineno">62</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">  <a href="" title="typedef std::ostream">std::ostream</a> &amp;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#my_os" title="data member Synopsis::SymbolLookup::ScopeDisplay::my_os">my_os</a>;</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">  <a href="" title="typedef size_t">size_t</a>        <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#my_indent" title="data member Synopsis::SymbolLookup::ScopeDisplay::my_indent">my_indent</a>;</span>
<a id="line65"></a><span class="lineno">65</span><span class="line">};</span>
<a id="line66"></a><span class="lineno">66</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">inline <span class="keyword">void</span> <a href="" title="function Synopsis::SymbolLookup::display(const Scope*,std::ostream&amp;)">display</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">SymbolLookup::Scope const</a> *s, <a href="" title="typedef std::ostream">std::ostream</a> &amp;os)</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">{</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html" title="class Synopsis::SymbolLookup::ScopeDisplay">ScopeDisplay</a> <a href="" title="local variable sd">sd</a>(os);</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">  <a href="" title="local variable sd">sd</a>.<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeDisplay.html#display_lconst.Scope_S_r" title="member function Synopsis::SymbolLookup::ScopeDisplay::display(const Scope*)">display</a>(<a href="" title="parameter s">s</a>);</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">}</span>
<a id="line72"></a><span class="lineno">72</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">}</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">}</span>
<a id="line75"></a><span class="lineno">75</span>
<a id="line76"></a><span class="lineno">76</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:02 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
